DIM Pixel AS STRING * 1

Source$ = "Image.RAW"
Target$ = "Image.BIN"
Header$ = "HPHP49-B"

CLS
PRINT "RAW_GREYSCALE to HP4x_GREYSCALE Converter / (c)2000 by NumLOCK"
PRINT "--------------------------------------------------------------"
PRINT "Source File = "; Source$
PRINT "Target File = "; Target$
INPUT "X Resolution "; ResX&
INPUT "Y Resolution "; ResY&
INPUT "Color Depth = "; cDepth%
PRINT
IF cDepth% = 0 THEN
  cDepth% = 5
  PRINT "!! Assuming Default Color Depth (gDREAM) :"; cDepth%
END IF
IF cDepth% <> 5 THEN
  PRINT "!! WARNING: gDREAM Only Supports 5-Bit Color Depth"
END IF
PRINT "!! Converting from 256 to"; 2 ^ cDepth%; "colors"
PRINT : PRINT "Opening Target File !"
OPEN Target$ FOR OUTPUT AS #2: CLOSE #2
OPEN Target$ FOR BINARY AS #2

Index2& = 1
Mask% = 256

' *** Header fichier
PRINT " Writing File Header: "; Header$
PUT #2, Index2&, Header$
Index2& = Index2& + LEN(Header$)

' *** Header GROB
Header2$ = ""
Nibbles% = 0
Word& = &H2B1E: GOSUB AddToHeader
Word& = ((ResX& + 7) \ 8) * 2 * ResY& * cDepth% + 15: GOSUB AddToHeader
Word& = ResY& * cDepth%: GOSUB AddToHeader
Word& = ResX&: GOSUB AddToHeader
PRINT " Writing GROB Header: (HeaderSize"; 2 * LEN(Header2$); "nibbles)"
PUT #2, Index2&, Header2$
Index2& = Index2& + 10

FOR Bit% = 8 - 1 TO 8 - cDepth% STEP -1
  PRINT " Writing Pict Data  : (ColorDepth"; cDepth%; "Plane"; (8 - 1) - Bit%; ")"
  Index& = 1
  Mask% = Mask% \ 2
  nBits% = 0
  Incr% = 1
  Pix2% = 0
  OPEN Source$ FOR BINARY AS #1
    FOR Y% = 0 TO ResY& - 1
      FOR X% = 0 TO ResX& - 1
        GET #1, Index&, Pixel
        Pixel2% = 255 - ASC(Pixel)
        IF (Pixel2% AND Mask%) <> 0 THEN Pix2% = Pix2% + Incr%
        Incr% = Incr% + Incr%
        nBits% = nBits% + 1
        GOSUB WriteByte
        Index& = Index& + 1
      NEXT X%
      IF nBits% <> 0 THEN
        nBits% = 8: GOSUB WriteByte
      END IF
    NEXT Y%
  CLOSE #1
NEXT Bit%

PRINT "Closing Target File !"
CLOSE #2

PRINT : PRINT "Operation Completed. Press Any Key To Continue ...": PRINT
DO WHILE INKEY$ = "": LOOP
END

WriteByte:
  IF nBits% = 8 THEN
    PUT #2, Index2&, Pix2%
    Index2& = Index2& + 1
    Pix2% = 0
    nBits% = 0
    Incr% = 1
 END IF
RETURN

AddToHeader:
  FOR i% = 1 TO 5
    Nibb% = Word& AND 15
    IF (Nibbles% AND 1) = 0 THEN
      Header2$ = Header2$ + CHR$(Nibb%)
    ELSE
      MID$(Header2$, LEN(Header2$), 1) = CHR$(ASC(RIGHT$(Header2$, 1)) + 16 * Nibb%)
    END IF
    Word& = Word& \ 16
    Nibbles% = Nibbles% + 1
  NEXT i%
RETURN

